<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>

    <div id="app">
        Nama: <input type="text" placeholder="Nama" v-model:value="member.name" :disabled="disabledInput" /><br>
        Alamat: <input type="text" placeholder="Alamat" v-model:value="member.address" :disabled="disabledInput" /><br>
        No. HP: <input type="text" placeholder="Nomor HP" v-model:value="member.no_hp" :disabled="disabledInput" /><br>
        Foto Profil: 
        <span v-if="member.photo_profile"> {{ member.photo_profile }} </span>
        <span v-else> None </span><br>  
        
        <img v-if="member.photo_profile" v-bind:src="'https://demo-api-vue.sanbercloud.com/' + member.photo_profile"  width="100"> 
        <img v-else v-bind:src="'https://demo-api-vue.sanbercloud.com/photo/foto-profile/_536_202107271321.png'"  width="100"> <br><br>

        <button @click="createMember()" v-if="createButton">Create</button>
        <button @click="updateMember(member.id)" v-if="updateButton">Update</button>
        
        <input type="file" @change="onSelect" ref="filename" v-if="uploadButton" accept="image/*"><br>
        <button @click="uploadPhoto(member.id)" v-if="uploadButton">Upload Photo</button>

        <h3>Data Member</h3>
        <ul>
            <li v-for="member of members" :key="member.id"> {{ member.id }}, {{ member.name }}, {{ member.address }}, {{ member.no_hp }} 
                <button @click="editMember(member.id)">Edit</button>||
                <button @click="photoMember(member.id)">Upload Photo</button>||
                <button @click="deleteMember(member.id)">Delete</button>
            </li>
        </ul>

    </div>
    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        var api = axios.create({
            baseURL : 'http://demo-api-vue.sanbercloud.com/api/member'
        });
        
        let vm = new Vue({
            el : '#app',
            data : {
                msg : 'Belajar AJAX menggunakan Axios',
                members : [],
                member : {},
                createButton : true,
                updateButton : false,
                uploadButton : false,
                disabledInput : false,
                file : ""
            },

            methods : {
                // getAll : function() {
                //     axios.get('http://demo-api-vue.sanbercloud.com/api/member')
                //         .then( (res) => {
                //             this.members = res.data.members
                //             console.log(members)
                //         })
                //         .catch((err) => {
                //             console.log(err)
                //         })
                //     }
                // },

                getAll : async function() {
                    try {
                            this.disabledInput = false
                            const config = {
                                method: 'get',
                                url : '',
                                
                            }
                            const res = await api(config)
                            this.members = res.data.members
                            console.log(this.members)
                    } catch (error) {
                        console.log(error)
                    }
                },

                editMember : async function (id) {
                    try {

                        this.disabledInput = false
                        this.createButton = false
                        this.updateButton = true
                        this.uploadButton = false

                        const config = {
                                method: 'get',
                                url : `/${id}`,
                                
                        }
                        const res = await api(config)
                        this.member = res.data.member
                        
                    } catch (error) {
                        console.log(error)
                    }
                },

                createMember : async function (member) {
                    try {
                        const config = {
                                method: 'post',
                                url : '',
                                data : {
                                    name : this.member.name,
                                    address : this.member.address,
                                    no_hp : this.member.no_hp
                                }
                                
                            }
                            console.log(config)
                            const res = await api(config)
                            this.getAll()
                         
                        
                    } catch (error) {
                        
                    }
                },
                
                updateMember : async function (id) {
                    try {
                        const config = {
                                method: 'put',
                                url : `/${id}`,
                                data : {
                                    name : this.member.name,
                                    address : this.member.address,
                                    no_hp : this.member.no_hp
                                }
                                
                            }
                        console.log(config)
                        const res = await api(config)
                        console.log(res)
                        this.createButton = true
                        this.updateButton = false
                        this.disabledInput = false
                        this.getAll()
                    
                    } catch (error) {
                        
                    }
                },
                deleteMember : async function (id) {
                    try {
                        const config = {
                                method: 'delete',
                                url : `/${id}`,                                
                            }
                        const res = await api(config)
                        this.getAll()
                        
                    } catch (error) {
                        
                    }
                },
                photoMember : async function (id) {
                    try {

                        this.createButton = false
                        this.updateButton = false
                        this.uploadButton = true
                        this.disabledInput = true

                        const config = {
                                method: 'get',
                                url : `/${id}`,
                                
                        }
                        const res = await api(config)
                        this.member = res.data.member
                        
                    } catch (error) {
                        console.log(error)
                    }
                },
                onSelect : function () {
                    const file = this.$refs.filename.files[0]
                    this.file = file
                    //console.log(this.$refs.filename.files[0])
                },
                uploadPhoto : async function (id) {
                    try {
                        const formData = new FormData()
                        formData.append('photo_profile', this.file)
                        const config = {
                                method: 'post',
                                url : `/${id}/upload-photo-profile`,
                                data : formData,
                                'Content-Type': 'multipart/form-data'
                                
                            }
                        console.log(config)
                        const res = await api(config)
                        console.log(res)
                        this.createButton = true
                        this.updateButton = false
                        this.getAll()
                    
                    } catch (error) {
                        
                    }
                },
            },
            created() {
                this.getAll()
            }


        });
    </script>
    
    
</body>
</html>